%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% ellipse
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Reference:
%   Mathematical and Computational Methods in Photonics and Phononics
%
% Authors:
%   Habib Ammari, Brian Fitzpatrick, Hyeonbae Kang,
%   Matias Ruiz, Sanghyeon Yu, Hai Zhang
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function c2Ellipse = ellipse(a, b, cx, cy, nbPoints)


theta = 2*pi*(0:nbPoints-1)/nbPoints;

points = [a*cos(theta)+cx ; b*sin(theta)+cy];
tvec = [-a*sin(theta) ; b*cos(theta)];
avec = [-a*cos(theta) ; -b*sin(theta)];
diff_parameter = ones(1,nbPoints)*2*pi/nbPoints;
c2Ellipse = C2boundary(points, tvec, avec, diff_parameter);

end

