%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% exact_sol
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Reference:
%   Mathematical and Computational Methods in Photonics and Phononics
%
% Authors:
%   Habib Ammari, Brian Fitzpatrick, Hyeonbae Kang,
%   Matias Ruiz, Sanghyeon Yu, Hai Zhang
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function value = exact_sol(k_c,k_m,mu_m,mu_c,R,NN)

Jc = besselj(0,k_c*R);
Jc_deri = -besselj(1,k_c*R);
Hc = besselh(0,1,k_c*R);
Hc_deri = -besselh(1,1,k_c*R);
Hm = besselh(0,1,k_m*R);
Hm_deri = -besselh(1,1,k_m*R);

det = k_c/mu_c*Jc_deri*Hm - k_m/mu_m*Jc*Hm_deri;
a=(1i/4)*1/det*(k_c/mu_c*Hm*Hc_deri - k_m/mu_m*Hc*Hm_deri);
b=(1i/4)*1/det*(k_c/mu_c*Jc*Hc_deri - k_c/mu_c*Jc_deri*Hc);

value = zeros(NN+1,1);
for j=1:2*NN-1
    value(j) = a*besselj(0,k_c*abs(-R+(j)/NN*R));
end